package com.bonait.bnframework.business.deviceControl;

public class DeviceManager {
    //region 单例模式
    private static volatile DeviceManager instance = null;
    public static DeviceManager get() {
        DeviceManager manager = instance;
        if (manager == null) {
            synchronized (DeviceManager.class) {
                manager = instance;
                if (manager == null) {
                    manager = new DeviceManager();
                    instance = manager;
                }
            }
        }
        return manager;
    }
    //endregion
}
