package com.bonait.bnframework;

import android.app.Activity;
import android.app.Dialog;
import android.content.Context;
import android.os.Build;
import android.os.Bundle;
import android.text.InputType;
import android.view.MotionEvent;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;

import androidx.annotation.NonNull;

import com.bonait.bnframework.HBL.Dialog.AlertDialogButton;
import com.bonait.bnframework.HBL.Dialog.DialogHelper;
import com.bonait.bnframework.business.ControlEnum;
import com.bonait.bnframework.business.FryingpanModbusHelper;
import com.bonait.bnframework.common.constant.ConfigName;
import com.bonait.bnframework.common.helper.I.MyClickListener;
import com.bonait.bnframework.common.model.mode.MouthFacingEnum;
import com.bonait.bnframework.common.model.mode.SpeedEnum;
import com.bonait.bnframework.common.utils.AlertDialogUtils;
import com.bonait.bnframework.common.utils.ToastUtils;
import com.bonait.bnframework.modules.home.fragment.mode.imagebuttom3;
import com.bonait.bnframework.modules.home.fragment.mode.newhuoli_control;
import com.qmuiteam.qmui.widget.dialog.QMUIDialog;
import com.qmuiteam.qmui.widget.dialog.QMUIDialogAction;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;

public class device_control extends Dialog {

    //region 控件绑定
    @BindView(R.id.touliao_k)
    LinearLayout touliao_k;

//    @BindView(R.id.touliao_m)
//    LinearLayout touliao_m;

    @BindView(R.id.plcstatus1)
    ImageView plcstatus1;

    @BindView(R.id.zidongqingxi)
    RelativeLayout zidongqingxi;

    @BindView(R.id.chushihua)
    RelativeLayout chushihua;

    @BindView(R.id.huoli)
    newhuoli_control huoli;

    @BindView(R.id.fanchaoshudu_1)
    LinearLayout fanchaoshudu_1;

    @BindView(R.id.fanchaoshudu)
    imagebuttom3 fanchaoshudu;

    @BindView(R.id.fanchaoshudu_k)
    imagebuttom3 fanchaoshudu_k;

    @BindView(R.id.fanchaoshudu_z)
    imagebuttom3 fanchaoshudu_z;

    @BindView(R.id.fanchaoshudu_m)
    imagebuttom3 fanchaoshudu_m;

    @BindView(R.id.fanchaoshudu_t)
    imagebuttom3 fanchaoshudu_t;

    @BindView(R.id.guokoucaoxiang_1)
    LinearLayout guokoucaoxiang_1;

    @BindView(R.id.guokoucaoxiang)
    imagebuttom3 guokoucaoxiang;

    @BindView(R.id.guokoucaoxiang_cc)
    imagebuttom3 guokoucaoxiang_cc;

    @BindView(R.id.guokoucaoxiang_wh)
    imagebuttom3 guokoucaoxiang_wh;

    @BindView(R.id.guokoucaoxiang_cl)
    imagebuttom3 guokoucaoxiang_cl;

    @BindView(R.id.guokoucaoxiang_dc)
    imagebuttom3 guokoucaoxiang_dc;

    @BindView(R.id.guokoucaoxiang_qx)
    imagebuttom3 guokoucaoxiang_qx;

    @BindView(R.id.guokoucaoxiang_yd)
    imagebuttom3 guokoucaoxiang_yd;

    @BindView(R.id.chushui)
    imagebuttom3 chushui;

    @BindView(R.id.xiguoshui)
    imagebuttom3 xiguoshui;

//    @BindView(R.id.touliao1)
//    imagebuttom3 touliao1;
//
//    @BindView(R.id.touliao2)
//    imagebuttom3 touliao2;
//
//    @BindView(R.id.touliao3)
//    imagebuttom3 touliao3;
//
//    @BindView(R.id.touliao4)
//    imagebuttom3 touliao4;

    @BindView(R.id.yeliao1)
    imagebuttom3 yeliao1;

    @BindView(R.id.yeliao2)
    imagebuttom3 yeliao2;

    @BindView(R.id.yeliao3)
    imagebuttom3 yeliao3;

    @BindView(R.id.chuchan)
    imagebuttom3 chuchan;

    @BindView(R.id.chaoguo_wendu)
    TextView chaoguo_wendu;

    @BindView(R.id.device_image)
    ImageView device_image;

    @BindView(R.id.close_dialog)
    Button close_dialog;

    @BindView(R.id.titleName)
    TextView titleName;

    private boolean IsShow=true;
    private Context context;

    public Activity activity = null;
    private int DeviceNum=0;
    //endreigon

    public device_control(@NonNull Context _context,Activity _activity,int deviceNum) {
        super(_context, R.style.mydialog);
        setContentView(R.layout.activity_device_control);
        context=_context;
        activity=_activity;
        DeviceNum=deviceNum;
        Window mWindow = getWindow();
        mWindow.setWindowAnimations(0);
        fullScreen(mWindow);
        this.setCanceledOnTouchOutside(false);//禁用触摸其它区域关闭弹框
    }

    private void fullScreen(Window window){
        try{
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.JELLY_BEAN) {
                if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {
                    // 全屏显示，隐藏状态栏和导航栏，拉出状态栏和导航栏显示一会儿后消失。
                    // 启动游戏模式，设置状态栏和导航栏中的图标变小，变模糊或者弱化其效果
                    window.getDecorView().setSystemUiVisibility(
                            View.SYSTEM_UI_FLAG_LOW_PROFILE
                                    | View.SYSTEM_UI_FLAG_LAYOUT_STABLE
                                    | View.SYSTEM_UI_FLAG_LAYOUT_FULLSCREEN
                                    | View.SYSTEM_UI_FLAG_LAYOUT_HIDE_NAVIGATION
                                    | View.SYSTEM_UI_FLAG_HIDE_NAVIGATION
                                    | View.SYSTEM_UI_FLAG_FULLSCREEN
                                    | View.SYSTEM_UI_FLAG_IMMERSIVE_STICKY);
                    //activity.getWindow().getDecorView().setSystemUiVisibility(View.SYSTEM_UI_FLAG_HIDE_NAVIGATION|View.SYSTEM_UI_FLAG_FULLSCREEN);
                    //activity.getWindow().getDecorView().setSystemUiVisibility(View.SYSTEM_UI_FLAG_FULLSCREEN | View.SYSTEM_UI_FLAG_HIDE_NAVIGATION);
                } else {
                    // 全屏显示，隐藏状态栏
                    window.getDecorView().setSystemUiVisibility(View.INVISIBLE);
                }
            }
        }catch ( Exception e){

        }
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_device_control);
        ButterKnife.bind(this);
        initTopBar();
        initData();
        SxUIThread();
        close_dialog.setOnClickListener((view)->{
            if(this.isShowing()){
                IsShow=false;
                this.dismiss();
            }
        });
        titleName.setText(DeviceNum+"号炒锅");
        huoli.DeviceNum=DeviceNum;
    }

    private  boolean verification(){
        if(!FryingpanModbusHelper.getInstance().isConnect(DeviceNum)){
            DialogHelper.showError(activity,DeviceNum+"号炒锅设备未连接！", AlertDialogButton.OK,null);
            return false;
        }
        if(FryingpanModbusHelper.getInstance().getMake(DeviceNum)){
            DialogHelper.showWarn(activity,DeviceNum+"号炒锅设备正在运行中！", AlertDialogButton.OK,null);
            return false;
        }
        return true;
    }
//
//    private View.OnTouchListener Tounch=new View.OnTouchListener() {
//        @Override
//        public boolean onTouch(View view, MotionEvent motionEvent) {
//            if(motionEvent.getAction() == MotionEvent.ACTION_DOWN){
//                if(!FryingpanModbusHelper.getInstance().isConnect(DeviceNum)){
//                    DialogHelper.showError(activity,DeviceNum+"号炒锅设备未连接！", AlertDialogButton.OK,null);
//                    return false;
//                }
//                switch (view.getId()){
//                    case R.id.xiguoshui:
//                        if(!FryingpanModbusHelper.getInstance().getClearLocFeedback(DeviceNum)){
//                            DialogHelper.showWarn(activity,DeviceNum+"号炒锅锅口不在清洗位，不允许清洗！", AlertDialogButton.OK,null);
//                            return false;
//                        }
//                        break;
//                    case R.id.chushui:
//                    case R.id.yeliao1:
//                    case R.id.yeliao2:
//                    case R.id.yeliao3:
//                        if(!FryingpanModbusHelper.getInstance().getMaterialLocFeedback(DeviceNum)){
//                            DialogHelper.showWarn(activity,DeviceNum+"号炒锅锅口不在抽料位，不允许抽料！", AlertDialogButton.OK,null);
//                            return false;
//                        }
//                        break;
//                }
//            }
//            if (motionEvent.getAction() == MotionEvent.ACTION_DOWN) {
//                InchingControl(view,true);
//            } else if (motionEvent.getAction() == MotionEvent.ACTION_UP) {
//                InchingControl(view,false);
//            }
//            return false;
//        }
//    };

    private void InchingControl(int id,Boolean IsCheck){
        switch (id){
            case R.id.yeliao1:
                FryingpanModbusHelper.getInstance().deviceControl(DeviceNum,ControlEnum.料仓1手动开关,IsCheck);
                break;
            case R.id.yeliao2:
                FryingpanModbusHelper.getInstance().deviceControl(DeviceNum,ControlEnum.料仓2手动开关,IsCheck);
                break;
            case R.id.yeliao3:
                FryingpanModbusHelper.getInstance().deviceControl(DeviceNum,ControlEnum.料仓3手动开关,IsCheck);
                break;
            case R.id.chushui:
                FryingpanModbusHelper.getInstance().deviceControl(DeviceNum,ControlEnum.料仓4手动开关,IsCheck);
                break;
            case R.id.xiguoshui:
                FryingpanModbusHelper.getInstance().deviceControl(DeviceNum,ControlEnum.炒锅放水,IsCheck);
                break;
        }
    }

    private void OnTouch1(int id,MotionEvent motionEvent){
        if(motionEvent.getAction() == MotionEvent.ACTION_DOWN){
            if(!FryingpanModbusHelper.getInstance().isConnect(DeviceNum)){
                DialogHelper.showError(activity,DeviceNum+"号炒锅设备未连接！", AlertDialogButton.OK,null);
                return ;
            }
            switch (id){
                case R.id.xiguoshui:
                    if(!FryingpanModbusHelper.getInstance().getClearLocFeedback(DeviceNum)){
                        DialogHelper.showWarn(activity,DeviceNum+"号炒锅锅口不在清洗位，不允许清洗！", AlertDialogButton.OK,null);
                        return ;
                    }
                    break;
                case R.id.chushui:
                case R.id.yeliao1:
                case R.id.yeliao2:
                case R.id.yeliao3:
                    if(!FryingpanModbusHelper.getInstance().getMaterialLocFeedback(DeviceNum)){
                        DialogHelper.showWarn(activity,DeviceNum+"号炒锅锅口不在抽料位，不允许抽料！", AlertDialogButton.OK,null);
                        return ;
                    }
                    break;
            }
        }

        if (motionEvent.getAction() == MotionEvent.ACTION_DOWN) {
            InchingControl(id,true);
        } else if (motionEvent.getAction() == MotionEvent.ACTION_UP) {
            InchingControl(id,false);
        }
    }

    private void SetOnTounch(){
//        chushui.SetOnTounch((View view, MotionEvent motionEvent)->{
//            OnTouch1(R.id.chushui,motionEvent);
//            return false;
//        });
//
//        xiguoshui.SetOnTounch((View view, MotionEvent motionEvent)->{
//            OnTouch1(R.id.xiguoshui,motionEvent);
//            return false;
//        });
//
//        yeliao1.SetOnTounch((View view, MotionEvent motionEvent)->{
//            OnTouch1(R.id.yeliao1,motionEvent);
//            return false;
//        });
//
//        yeliao2.SetOnTounch((View view, MotionEvent motionEvent)->{
//            OnTouch1(R.id.yeliao2,motionEvent);
//            return false;
//        });
//
//        yeliao3.SetOnTounch((View view, MotionEvent motionEvent)->{
//            OnTouch1(R.id.yeliao3,motionEvent);
//            return false;
//        });


        chushui.SetOnTounch(new View.OnTouchListener() {
            @Override
            public boolean onTouch(View view, MotionEvent motionEvent) {
                if(motionEvent.getAction() == MotionEvent.ACTION_DOWN){
                    if(!FryingpanModbusHelper.getInstance().isConnect(DeviceNum)){
                        DialogHelper.showError(activity,DeviceNum+"号炒锅设备未连接！", AlertDialogButton.OK,null);
                        return false;
                    }
                    if(!FryingpanModbusHelper.getInstance().getMaterialLocFeedback(DeviceNum)){
                        DialogHelper.showWarn(activity,DeviceNum+"号炒锅锅口不在抽料位，不允许抽料！", AlertDialogButton.OK,null);
                        return false;
                    }
                }

                if (motionEvent.getAction() == MotionEvent.ACTION_DOWN) {
                    InchingControl(R.id.chushui,true);
                } else if (motionEvent.getAction() == MotionEvent.ACTION_UP) {
                    InchingControl(R.id.chushui,false);
                }
                return false;
            }
        });
        xiguoshui.SetOnTounch(new View.OnTouchListener() {
            @Override
            public boolean onTouch(View view, MotionEvent motionEvent) {
                if(motionEvent.getAction() == MotionEvent.ACTION_DOWN){
                    if(!FryingpanModbusHelper.getInstance().isConnect(DeviceNum)){
                        DialogHelper.showError(activity,DeviceNum+"号炒锅设备未连接！", AlertDialogButton.OK,null);
                        return false;
                    }
                    if(!FryingpanModbusHelper.getInstance().getClearLocFeedback(DeviceNum)){
                        DialogHelper.showWarn(activity,DeviceNum+"号炒锅锅口不在清洗位，不允许清洗！", AlertDialogButton.OK,null);
                        return false;
                    }
                }
                if (motionEvent.getAction() == MotionEvent.ACTION_DOWN) {
                    InchingControl(R.id.xiguoshui,true);
                } else if (motionEvent.getAction() == MotionEvent.ACTION_UP) {
                    InchingControl(R.id.xiguoshui,false);
                }
                return false;
            }
        });
        yeliao1.SetOnTounch(new View.OnTouchListener() {
            @Override
            public boolean onTouch(View view, MotionEvent motionEvent) {
                if(motionEvent.getAction() == MotionEvent.ACTION_DOWN){
                    if(!FryingpanModbusHelper.getInstance().isConnect(DeviceNum)){
                        DialogHelper.showError(activity,DeviceNum+"号炒锅设备未连接！", AlertDialogButton.OK,null);
                        return false;
                    }
                    if(!FryingpanModbusHelper.getInstance().getMaterialLocFeedback(DeviceNum)){
                        DialogHelper.showWarn(activity,DeviceNum+"号炒锅锅口不在抽料位，不允许抽料！", AlertDialogButton.OK,null);
                        return false;
                    }
                }

                if (motionEvent.getAction() == MotionEvent.ACTION_DOWN) {
                    InchingControl(R.id.yeliao1,true);
                } else if (motionEvent.getAction() == MotionEvent.ACTION_UP) {
                    InchingControl(R.id.yeliao1,false);
                }
                return false;
            }
        });
        yeliao2.SetOnTounch(new View.OnTouchListener() {
            @Override
            public boolean onTouch(View view, MotionEvent motionEvent) {
                if(motionEvent.getAction() == MotionEvent.ACTION_DOWN){
                    if(!FryingpanModbusHelper.getInstance().isConnect(DeviceNum)){
                        DialogHelper.showError(activity,DeviceNum+"号炒锅设备未连接！", AlertDialogButton.OK,null);
                        return false;
                    }
                    if(!FryingpanModbusHelper.getInstance().getMaterialLocFeedback(DeviceNum)){
                        DialogHelper.showWarn(activity,DeviceNum+"号炒锅锅口不在抽料位，不允许抽料！", AlertDialogButton.OK,null);
                        return false;
                    }
                }

                if (motionEvent.getAction() == MotionEvent.ACTION_DOWN) {
                    InchingControl(R.id.yeliao2,true);
                } else if (motionEvent.getAction() == MotionEvent.ACTION_UP) {
                    InchingControl(R.id.yeliao2,false);
                }
                return false;
            }
        });
        yeliao3.SetOnTounch(new View.OnTouchListener() {
            @Override
            public boolean onTouch(View view, MotionEvent motionEvent) {
                if(motionEvent.getAction() == MotionEvent.ACTION_DOWN){
                    if(!FryingpanModbusHelper.getInstance().isConnect(DeviceNum)){
                        DialogHelper.showError(activity,DeviceNum+"号炒锅设备未连接！", AlertDialogButton.OK,null);
                        return false;
                    }
                    if(!FryingpanModbusHelper.getInstance().getMaterialLocFeedback(DeviceNum)){
                        DialogHelper.showWarn(activity,DeviceNum+"号炒锅锅口不在抽料位，不允许抽料！", AlertDialogButton.OK,null);
                        return false;
                    }
                }

                if (motionEvent.getAction() == MotionEvent.ACTION_DOWN) {
                    InchingControl(R.id.yeliao3,true);
                } else if (motionEvent.getAction() == MotionEvent.ACTION_UP) {
                    InchingControl(R.id.yeliao3,false);
                }
                return false;
            }
        });
    }

    /**
     * 初始化TopBar
     */
    private void initTopBar() {
        fanchaoshudu.mListener = myClickListener;
        fanchaoshudu_k.mListener = myClickListener;
        fanchaoshudu_z.mListener = myClickListener;
        fanchaoshudu_m.mListener = myClickListener;
        fanchaoshudu_t.mListener = myClickListener;

        guokoucaoxiang.mListener = myClickListener;
        guokoucaoxiang_cc.mListener = myClickListener;
        guokoucaoxiang_wh.mListener = myClickListener;
        guokoucaoxiang_cl.mListener = myClickListener;
        guokoucaoxiang_dc.mListener = myClickListener;
        guokoucaoxiang_qx.mListener = myClickListener;
        guokoucaoxiang_yd.mListener = myClickListener;

//        touliao1.mListener = myClickListener;
//        touliao2.mListener = myClickListener;
//        touliao3.mListener = myClickListener;
//        touliao4.mListener = myClickListener;

        SetOnTounch();

//        chushui.setOnTouchListener();
//        chushui.SetOnTounch(Tounch);
//        chushui.SetOnTounch(Tounch);
//        xiguoshui.SetOnTounch(Tounch);
//        yeliao1.SetOnTounch(Tounch);
//        yeliao2.SetOnTounch(Tounch);
//        yeliao3.SetOnTounch(Tounch);

        huoli.mListener = myClickListener;
        chuchan.mListener = myClickListener;

        yeliao1.setTag("未知");
        yeliao1.Init();
        yeliao2.setTag("未知");
        yeliao2.Init();
        yeliao3.setTag("未知");
        yeliao3.Init();
        MaterialSolicUpdate( FryingpanModbusHelper.getInstance().getMaterialName(DeviceNum));
    }

    private void MaterialSolicUpdate(String[] res){
        if(res!=null&&activity!=null&&res.length>=4){
            activity.runOnUiThread(()->{
                yeliao1.setTag(res[0]);
                yeliao1.Init();
                yeliao2.setTag(res[1]);
                yeliao2.Init();
                yeliao3.setTag(res[2]);
                yeliao3.Init();
            });
        }
    }

    /**
     * 初始化显示数据
     */
    private void initData() {
//        SetStirFrySpeed(SpeedEnum.停, false);
        if (ConfigName.getInstance().versionSelectionEnum.equals("大炒版本") || ConfigName.getInstance().versionSelectionEnum.contains("一拖")) {
            touliao_k.setVisibility(View.GONE);
//            touliao_m.setVisibility(View.GONE);
            device_image.setImageResource(R.mipmap.device00);
        } else {
            touliao_k.setVisibility(View.VISIBLE);
//            touliao_m.setVisibility(View.VISIBLE);
            device_image.setImageResource(R.mipmap.device1);
        }
    }

    /**
     * 刷新UI界面
     */
    public void SxUIThread() {

        FryingpanModbusHelper.getInstance().getModbus(DeviceNum,(modbus)->{
            chaoguo_wendu.setText(modbus.CurrentTemperature.getValue() + "°C");
            plcstatus1.setImageResource(modbus.ConnectStatus.getValue() ? R.mipmap.plc1 : R.mipmap.plc2);
        });

        FryingpanModbusHelper.getInstance().getModbus(DeviceNum,(modbus)->{
            modbus.CurrentTemperature.ChangeNotify=(s->{
                if(activity!=null){
                    activity.runOnUiThread(()->{
                        chaoguo_wendu.setText(s + "°C");
                    });
                }
            });
        });

        FryingpanModbusHelper.getInstance().getModbus(DeviceNum,(modbus)->{
            modbus.ConnectStatus.Register("手动控制界面",(s->{
                if(activity!=null){
                    activity.runOnUiThread(()->{
                        plcstatus1.setImageResource(s ? R.mipmap.plc1 : R.mipmap.plc2);
                    });
                }
            }));
        });


//        Task.Run(()->{
//            while (IsShow) {
//                if(activity!=null){
////                    Object val_wd = ExecuteTheRecipe.getListingValue("当前锅底温度");
//                    Object val_wd = FryingpanModbusHelper.getInstance().getCurrentTemperature(DeviceNum);
//                    activity.runOnUiThread(()->{
//                        if (val_wd != null) {
//                            chaoguo_wendu.setText(val_wd + "°C");
//                        } else {
//                            chaoguo_wendu.setText("??°C");
//                        }
//                        plcstatus1.setImageResource(FryingpanModbusHelper.getInstance().isConnect(DeviceNum) ? R.mipmap.plc1 : R.mipmap.plc2);
//                    });
//                }
//                Task.Delay(1000);
//            }
//        });
    }

    @OnClick({ R.id.zidongqingxi, R.id.chushihua,})
    public void onViewClicked(View view) {
        switch (view.getId()) {
            case R.id.chushihua://初始化
//                ExecuteTheRecipe.BottomClick("初始化");
                if(!verification())return;
                FryingpanModbusHelper.getInstance().SelfResetControl(DeviceNum,MouthFacingEnum.初始化);
                ToastUtils.warning("初始化");
                break;
            case R.id.zidongqingxi://自动清洗
//                ExecuteTheRecipe.BottomClick("炒锅清洗");
//                ToastUtils.warning("自动清洗");
                if(!verification())return;
                final QMUIDialog.EditTextDialogBuilder builder = new QMUIDialog.EditTextDialogBuilder(context);
                builder.setTitle("深度清洗抽水用量")
                        .setPlaceholder("在此输入您的用量")
                        .setInputType(InputType.TYPE_CLASS_NUMBER)
                        .setCanceledOnTouchOutside(false)
                        .setDefaultText("500")
                        .addAction("取消", new QMUIDialogAction.ActionListener() {
                            @Override
                            public void onClick(QMUIDialog dialog, int index) {
                                dialog.dismiss();
                            }
                        })
                        .addAction("确定", new QMUIDialogAction.ActionListener() {
                            @Override
                            public void onClick(QMUIDialog dialog, int index) {
                                CharSequence text = builder.getEditText().getText();
                                if (text != null && text.length() > 0) {
                                    String t = text.toString();
                                    int val=1000;
                                    try {
                                        val=Integer.parseInt(t);
                                    } catch (Exception ex) {
                                        ToastUtils.warning("输入格式出错！");
                                        return;
                                    }
//                                    ExecuteTheRecipe.WritePLC("清洗抽水量", val, null);
                                    FryingpanModbusHelper.getInstance().setPumpingCapacity(DeviceNum,(short) val);
                                    try {
                                        Thread.sleep(500);//等待写入成功
                                    } catch (InterruptedException e) {

                                    }
//                                    ExecuteTheRecipe.BottomClick("深度清洗");
                                    FryingpanModbusHelper.getInstance().SelfResetControl(DeviceNum,MouthFacingEnum.深度清洗);
                                    ToastUtils.warning("自动清洗");
                                    dialog.dismiss();
                                } else {
                                    ToastUtils.warning("用量不能为空！");
                                }
                            }
                        })
                        .create(AlertDialogUtils.mCurrentDialogStyle).show();
                break;
        }
    }

    /**
     * 点击事件
     */
    public MyClickListener myClickListener = new MyClickListener() {
        @Override
        public void clickListener(View v, Object data) {
            boolean isclick = false;
            int hl = 0;
            if (v.getId() == R.id.huoli) {
                hl = (int) data;
            } else {
                isclick = (boolean) data;
            }
            switch (v.getId()) {
                case R.id.fanchaoshudu:
                    fanchaoshudu_1.setVisibility(isclick ? View.VISIBLE : View.GONE);
                    break;
                case R.id.fanchaoshudu_k:
                    SetStirFrySpeed(SpeedEnum.快, isclick);
                    break;
                case R.id.fanchaoshudu_z:
                    SetStirFrySpeed(SpeedEnum.中, isclick);
                    break;
                case R.id.fanchaoshudu_m:
                    SetStirFrySpeed(SpeedEnum.慢, isclick);
                    break;
                case R.id.fanchaoshudu_t:
                    SetStirFrySpeed(SpeedEnum.停, isclick);
                    break;
                case R.id.guokoucaoxiang:
                    guokoucaoxiang_1.setVisibility(isclick ? View.VISIBLE : View.GONE);
                    break;
                case R.id.guokoucaoxiang_cc:
                    SetMouthFacing(MouthFacingEnum.炒菜位);
                    break;
                case R.id.guokoucaoxiang_yd:
                    SetMouthFacing(MouthFacingEnum.原点位);
                    break;
                case R.id.guokoucaoxiang_wh:
                    SetMouthFacing(MouthFacingEnum.维护位);
                    break;
                case R.id.guokoucaoxiang_cl:
                    SetMouthFacing(MouthFacingEnum.抽料位);
                    break;
                case R.id.guokoucaoxiang_dc:
                    SetMouthFacing(MouthFacingEnum.倒菜位);
                    break;
                case R.id.guokoucaoxiang_qx:
                    SetMouthFacing(MouthFacingEnum.清洗位);
                    break;
//                case R.id.touliao1:
//                    MainDish(1);
//                    break;
//                case R.id.touliao2:
//                    MainDish(2);
//                    break;
//                case R.id.touliao3:
//                    MainDish(3);
//                    break;
//                case R.id.touliao4:
//                    MainDish(4);
//                    break;
                case R.id.huoli:
                    SetFire(hl);
                    break;
                case R.id.chuchan:
                    GoOutToDinner();
                    break;

            }
        }

        @Override
        public void clickListenerNew(View v, int k, Object data) {

        }
    };


    /**
     * 设置翻炒速度
     * int 60 快 中 慢 停
     *
     * @param
     */
    public void SetStirFrySpeed(SpeedEnum speed, boolean isselectd) {
        if(!FryingpanModbusHelper.getInstance().isConnect(DeviceNum)){
            DialogHelper.showError(activity,DeviceNum+"号炒锅设备未连接！", AlertDialogButton.OK,null);
            return;
        }
        int _speed = 0;
        if (isselectd) {
            switch (speed) {
                case 快:
                    _speed = 60;
                    //fanchaoshudu_k.SetStatus(true);
                    fanchaoshudu_z.SetStatus(false);
                    fanchaoshudu_m.SetStatus(false);
                    fanchaoshudu_t.SetStatus(false);
                    fanchaoshudu.setTag("翻炒速度 快-按钮");
                    break;
                case 中:
                    _speed = 40;
                    fanchaoshudu_k.SetStatus(false);
                    //fanchaoshudu_z.SetStatus(true);
                    fanchaoshudu_m.SetStatus(false);
                    fanchaoshudu_t.SetStatus(false);
                    fanchaoshudu.setTag("翻炒速度 中-按钮");
                    break;
                case 慢:
                    _speed = 20;
                    fanchaoshudu_k.SetStatus(false);
                    fanchaoshudu_z.SetStatus(false);
                    //fanchaoshudu_m.SetStatus(true);
                    fanchaoshudu_t.SetStatus(false);
                    fanchaoshudu.setTag("翻炒速度 慢-按钮");
                    break;
                case 停:
                    _speed = 0;
                    fanchaoshudu_k.SetStatus(false);
                    fanchaoshudu_z.SetStatus(false);
                    fanchaoshudu_m.SetStatus(false);
                    //fanchaoshudu_t.SetStatus(true);
                    fanchaoshudu.setTag("翻炒速度 停-按钮");
                    break;
            }
        } else {
            _speed = 0;
            fanchaoshudu_k.SetStatus(false);
            fanchaoshudu_z.SetStatus(false);
            fanchaoshudu_m.SetStatus(false);
            fanchaoshudu_t.SetStatus(true);
            fanchaoshudu.setTag("翻炒速度 停-按钮");
        }
        fanchaoshudu_1.setVisibility(View.GONE);
        fanchaoshudu.Init();

        ToastUtils.warning("设置翻炒速度：" + speed.name());

        int final_speed = _speed;

        FryingpanModbusHelper.getInstance().setStir(DeviceNum, (short)_speed,final_speed==0?false:true );

//        ExecuteTheRecipe.WritePLC("搅拌速度", _speed, new IWriteCallBack() {
//            @Override
//            public void onSuccess() {
//                if (final_speed == 0) {
//                    ExecuteTheRecipe.WritePLC("搅拌", false, null);
//                } else {
//                    ExecuteTheRecipe.WritePLC("搅拌", true, null);
//                }
//            }
//
//            @Override
//            public void onFailure(String ErrorMsg) {
//            }
//        });
    }

    /**
     * 设置锅口朝向
     *
     * @param
     */
    public void SetMouthFacing(MouthFacingEnum mouth) {
        if(!verification())return;
        FryingpanModbusHelper.getInstance().SelfResetControl(DeviceNum,mouth);
        switch (mouth) {
            case 炒菜位:
//                ExecuteTheRecipe.BottomClick("炒菜位1");
                guokoucaoxiang.setTag("锅口朝向\n 炒菜位-按钮");
                break;
            case 原点位:
//                ExecuteTheRecipe.BottomClick("原点位");
                guokoucaoxiang.setTag("锅口朝向\n 原点位-按钮");
                break;
            case 维护位:
//                ExecuteTheRecipe.BottomClick("炒菜位1");
                guokoucaoxiang.setTag("锅口朝向\n 维护位-按钮");
                break;
            case 抽料位:
//                ExecuteTheRecipe.BottomClick("抽料位");
                guokoucaoxiang.setTag("锅口朝向\n 抽料位-按钮");
                break;
            case 倒菜位:
//                ExecuteTheRecipe.BottomClick("倒菜位");
                guokoucaoxiang.setTag("锅口朝向\n 倒菜位-按钮");
                break;
            case 清洗位:
//                ExecuteTheRecipe.BottomClick("清洗位");
                guokoucaoxiang.setTag("锅口朝向\n 清洗位-按钮");
                break;
        }
        guokoucaoxiang_1.setVisibility(View.GONE);
        guokoucaoxiang.Init();

        ToastUtils.warning("当前锅口朝向：" + mouth.name());
    }


    /**
     * 设置火力
     *
     * @param data
     */
    public void SetFire(int data) {
//        ExecuteTheRecipe.Write_PLC_HuoLI((int) data);
        if(!FryingpanModbusHelper.getInstance().isConnect(DeviceNum)){
            DialogHelper.showError(activity,DeviceNum+"号炒锅设备未连接！", AlertDialogButton.OK,null);
            return;
        }
        FryingpanModbusHelper.getInstance().setFire(DeviceNum,(short) data);
        ToastUtils.warning("设置火力：" + data + "档");
    }

    /**
     * 出餐
     *
     * @param
     */
    public void GoOutToDinner() {
//        ExecuteTheRecipe.BottomClick("出菜");
        if(!verification())return;
        FryingpanModbusHelper.getInstance().SelfResetControl(DeviceNum,MouthFacingEnum.出菜);
        ToastUtils.warning("出餐");
    }


//    /**
//     * 获取主料
//     *
//     * @param wz
//     * @return
//     */
//    public BPA_GOODSRECIPE Get主料(int wz) {
//        BPA_GOODSRECIPE pf = new BPA_GOODSRECIPE();
//        pf.materialType = 1;
//        pf.processname = "主料";
//        pf.processms = "主料(未知," + wz + "号位,0,直接投出,0)";
//        pf.processvalue = "主料名称,未知|主料位置," + wz + "号位|主料重量,0|投料动作,直接投出|烹饪(秒),0";
//        return pf;
//    }

//    /**
//     * 获取位置
//     *
//     * @param sd
//     * @return
//     */
//    public BPA_GOODSRECIPE Get位置(String sd, String name) {
//        BPA_GOODSRECIPE pf = new BPA_GOODSRECIPE();
//        pf.materialType = 1;
//        pf.processname = "位置";
//        pf.processms = "位置(" + sd + "," + name + ",0)";
//        pf.processvalue = "转动速度," + sd + "|位置动作," + name + "|延迟(秒),0";
//        return pf;
//    }


//    /**
//     * 抽水
//     */
//    public void PumpWater(boolean isselectd) {
////        ExecuteTheRecipe.WritePLC("炒锅抽水", isselectd, null);
//        //ToastUtils.warning("锅内加水：" + (isselectd ? "打开" : "关闭"));
//    }

//    /**
//     * 洗锅水枪
//     *
//     * @param isselectd
//     */
//    public void PotWashingWater(boolean isselectd) {
////        ExecuteTheRecipe.WritePLC("炒锅放水", isselectd, null);
//        FryingpanModbusHelper.getInstance().deviceControl(DeviceNum, ControlEnum.炒锅放水,isselectd);
//        //ToastUtils.warning("洗锅水枪：" + (isselectd ? "打开" : "关闭"));
//    }
//
//    public boolean isMake = false;
//
//    /**
//     * 投主菜品
//     *
//     * @param num
//     */
//    public void MainDish(int num) {
////        Object sb = ExecuteTheRecipe.ReadPLC("平移轴在1号位");
////        if (sb != null) {
////            if ((boolean) (sb)) {
////
////            } else {
////                ToastUtils.warning("平移轴未复位!!!");
////            }
////        } else {
////            ToastUtils.warning("PLC未连接!!!");
////        }
//        if (isMake == false) {
//            isMake = true;
//            new Thread(new Runnable() {
//                @Override
//                public void run() {
//                    BPA_GOODSRECIPE data1 = Get位置("高速", "炒菜位1");
////                    ExecuteTheRecipe.ExecuteOperationSteps(data1.processname, data1.processvalue);
//
//                    BPA_GOODSRECIPE data = Get主料(num);
////                    ExecuteTheRecipe.ExecuteOperationSteps(data.processname, data.processvalue);
//                    ToastUtils.warning("主料：" + num + "号仓投放");
//                    isMake = false;
//                }
//            }).start();
//        }else
//        {
//            ToastUtils.warning("请耐心等待上一次投料结束!!!");
//        }
//    }
//
//    /**
//     * 抽料
//     *
//     * @param num
//     */
//    public void Pumping(int num, boolean isselectd) {
////        ExecuteTheRecipe.WritePLC("料仓" + (num) + "手动开关", isselectd, null);
//        //ToastUtils.warning("料仓：" + num + "," + (isselectd ? "打开" : "关闭"));
//    }

    //
//    /**
//     * 设置是否按下
//     *
//     * @param id
//     * @param ismode
//     */
//    public void SetIDTouch(int id, boolean ismode) {
//        switch (id) {
//            case R.id.chushui:
//                //PumpWater(ismode);
//                Pumping(4, ismode);
//                Log.e("锅内加水", ismode ? "按下" : "松开");
//                break;
//            case R.id.xiguoshui:
//                PotWashingWater(ismode);
//                Log.e("洗锅水枪", ismode ? "按下" : "松开");
//                break;
//            case R.id.yeliao1:
//                Pumping(1, ismode);
//                Log.e("液料1号", ismode ? "按下" : "松开");
//                break;
//            case R.id.yeliao2:
//                Pumping(2, ismode);
//                Log.e("液料2号", ismode ? "按下" : "松开");
//                break;
//            case R.id.yeliao3:
//                Pumping(3, ismode);
//                Log.e("液料3号", ismode ? "按下" : "松开");
//                break;
//        }
//    }


}