package com.bonait.bnframework.HBL;

import android.app.Notification;

import com.bonait.bnframework.common.helper.I.IRunT;
import com.bumptech.glide.disklrucache.DiskLruCache;

import java.io.Serializable;
import java.util.LinkedHashMap;

import butterknife.Action;

public class NotifyPropVar<T extends Serializable>   {

    public NotifyPropVar(T defaultValue){
        _value=defaultValue;
    }
    public IRunT<T> ChangeNotify;

    private boolean IsFirst=false;
    private LinkedHashMap<String,IRunT<T>> changedNotifys=new LinkedHashMap<>();

    public void Register(String key,IRunT<T> notify){
        changedNotifys.put(key,notify);
    }

    private T _value;
    //    public  T getValue(){ return _value; }
    public <T> T getValue(){ return (T) _value; }
    public void setValue(T value){
        if (value != null && !value.equals(_value) || !IsFirst) {
            _value=value;
            if(ChangeNotify!=null) ChangeNotify.Run(value);
            changedNotifys.values().forEach(item->{if(item!=null) item.Run(value);});
            IsFirst = true;
        }
    }
}
