package com.bonait.bnframework.HBL;

import com.bonait.bnframework.common.helper.I.IRun;
import com.bonait.bnframework.common.helper.MessageLog;

public class Task {
    public static void Run(IRun action){
        if(action!=null){
            new Thread(()->{
                try{
                    action.Run();
                }catch(Exception e){
                    MessageLog.ShowError(e.getMessage());
                }
            }).start();
        }
    }

    public static void Delay(long millis){
        try{
            Thread.sleep(millis);
        }catch (Exception e){}
    }
}
