package com.bonait.bnframework.business.deviceControl;

import com.bonait.bnframework.common.helper.I.IWriteCallBack;

/**电子秤设备接口*/
public interface ScaleAble {
    /**设备初始化*/
    void Inital(IWriteCallBack callBack);
    /**获取当前重量*/
    int getCurrentWeight();
    void writeCounterWeight(short counterWeight, IWriteCallBack callBack);
    /**去皮*/
    void tare(IWriteCallBack callBack);
    /**恢复去皮*/
    void cancelTare(IWriteCallBack callBack);
    /**零点校准，写入前需要先关闭写保护*/
    void zeroScale(IWriteCallBack callBack);

    /**恢复出厂设置，写入前需要先关闭写保护*/
    void factoryReset(IWriteCallBack callBack);

    /**打开写保护*/
    void openWriteProtect(IWriteCallBack callBack);
    /**关闭写保护，零点校准、写入砝码重量、恢复出厂设置都需要先执行此操作*/
    void closeWriteProtect(IWriteCallBack callBack);
}
