package com.bonait.bnframework.business.deviceControl.seasonBar;

import com.bonait.bnframework.business.deviceControl.ScaleAble;
import com.bonait.bnframework.common.helper.DataFormat;
import com.bonait.bnframework.common.helper.I.IWriteCallBack;
import com.bonait.bnframework.common.modbus.ModbusMaster;
import com.bonait.bnframework.common.utils.ToastUtils;

/**电子秤实现类*/
public class ScaleDevice implements ScaleAble {

    //region 单例模式
    private static volatile ScaleDevice instance = null;
    public static ScaleDevice get() {
        ScaleDevice manager = instance;
        if (manager == null) {
            synchronized (ScaleDevice.class) {
                manager = instance;
                if (manager == null) {
                    manager = new ScaleDevice();
                    instance = manager;
                }
            }
        }
        return manager;
    }

    private ScaleDevice(){}
    //endregion
    private final int slaveId=2;

    @Override
    public void Inital(IWriteCallBack callBack) {

    }

    @Override
    public int getCurrentWeight() {
        int[] result=new int[]{0};
        try {
//            ModbusMaster.get().ReadInt("0",1,2, DataFormat.BADC,val->{
//                result[0]=val[0];
//            });
        }catch (Exception ex){
            ToastUtils.error("GetCurrentWeight error:" + ex.getMessage());
        }
        return result[0];
    }

    @Override
    public void writeCounterWeight(short counterWeight, IWriteCallBack callBack) {
        try {
//            ModbusMaster.get().WriteShort("6",counterWeight,slaveId,callBack);
        }catch (Exception ex){
            ToastUtils.error("Exception message:" + ex.getMessage());
        }
    }

    @Override
    public void tare(IWriteCallBack callBack) {
        try {
//            ModbusMaster.get().WriteShort("21",(short) 1,slaveId,callBack);
        }catch (Exception ex){
            ToastUtils.error("Exception message:" + ex.getMessage());
        }
    }

    @Override
    public void cancelTare(IWriteCallBack callBack) {
        try {
//            ModbusMaster.get().WriteShort("21",(short) 2,slaveId,callBack);
        }catch (Exception ex){
            ToastUtils.error("Exception message:" + ex.getMessage());
        }
    }

    @Override
    public void zeroScale(IWriteCallBack callBack) {
        try {
//            ModbusMaster.get().WriteShort("22",(short) 1,slaveId,callBack);
        }catch (Exception ex){
            ToastUtils.error("Exception message:" + ex.getMessage());
        }
    }

    @Override
    public void factoryReset(IWriteCallBack callBack) {
        try {
//            ModbusMaster.get().WriteShort("22",(short) 9,slaveId,callBack);
        }catch (Exception ex){
            ToastUtils.error("Exception message:" + ex.getMessage());
        }
    }

    @Override
    public void openWriteProtect(IWriteCallBack callBack) {
        try {
//            ModbusMaster.get().WriteShort("23",(short) 0,slaveId,callBack);
        }catch (Exception ex){
            ToastUtils.error("Exception message:" + ex.getMessage());
        }
    }

    @Override
    public void closeWriteProtect(IWriteCallBack callBack) {
        try {
//            ModbusMaster.get().WriteShort("23",(short) 1,slaveId,callBack);
        }catch (Exception ex){
            ToastUtils.error("Exception message:" + ex.getMessage());
        }
    }
}
