package com.bonait.bnframework.common.helper;

import android.util.Log;

import com.bonait.bnframework.HBL.Task;
import com.bonait.bnframework.common.constant.ConfigName;
import com.bonait.bnframework.common.helper.I.IThread;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.concurrent.ConcurrentHashMap;

public class TcpServer {
    private volatile static  TcpServer _Instance;
    public synchronized  static  TcpServer getInstance(){
        if(_Instance==null)_Instance=new TcpServer();
        return _Instance;
    }
    private  TcpServer(){}
    private ServerSocket serverSocket;
    private ConcurrentHashMap<String,TcpServerModel> devices=new ConcurrentHashMap();
    private boolean CloseFlag=false;
    public void startServer(int port) {
        Task.Run(()->{
            try{
                CloseFlag=false;
                serverSocket = new ServerSocket(port);
                MessageLog.ShowInfo(serverSocket.getLocalSocketAddress().toString());
                while (!CloseFlag) {
                    try{
                        // 监听客户端的连接
                        Socket clientSocket = serverSocket.accept();
                        if(devices.containsKey(clientSocket.getInetAddress().toString())){
                            devices.get(clientSocket.getInetAddress().toString()).Close();
                        }
                        devices.put(clientSocket.getInetAddress().toString(),new TcpServerModel(clientSocket));
                    }catch (Exception ex){}
                }
            }catch (Exception e){}
        });

//        ThreadManager.Get().StartLong("服务端监听", true, new IThread() {
//            @Override
//            public void Run() throws Exception {
//                 serverSocket = new ServerSocket(port);
//                MessageLog.ShowInfo(serverSocket.getLocalSocketAddress().toString());
//                while (true) {
//                    // 监听客户端的连接
//                    Socket clientSocket = serverSocket.accept();
//                    if(devices.containsKey(clientSocket.getInetAddress().toString())){
//                        devices.get(clientSocket.getInetAddress().toString()).Close();
//                    }
//                    devices.put(clientSocket.getInetAddress().toString(),new TcpServerModel(clientSocket));
//                }
//            }
//            @Override
//            public void RunComplete() throws Exception {
//
//            }
//        });
    }

    public void SendData(){
        try{
            if(ConfigName.getInstance().IsChangeGoods){
                devices.forEach((k,v)->{v.SendData();});
                ConfigName.getInstance().IsChangeGoods=false;
            }
        }catch (Exception e){

        }
    }

    public void stopServer() {
        try {
            if (serverSocket != null) {
                CloseFlag=true;
                serverSocket.close();
                ThreadManager.Get().Stop("服务端监听");
                devices.forEach((k,v)->{v.Close();});
                devices.clear();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }


}
