package com.bonait.bnframework.common.helper;

import android.util.Log;

import com.bonait.bnframework.HBL.Task;
import com.bonait.bnframework.common.constant.ConfigName;
import com.bonait.bnframework.common.db.QueryDB;
import com.bonait.bnframework.common.db.file.DBHelper;
import com.bonait.bnframework.common.helper.I.IRunT;
import com.bonait.bnframework.common.helper.I.IThread;
import com.bonait.bnframework.common.utils.ToastUtils;
import com.google.gson.Gson;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.Socket;

public class TcpServerModel {
    /**
     * 发送文件
     */
    public void  SendFile(){
        try{
            FileInputStream  fis = new FileInputStream( ConfigName.getInstance().dbPath );
            byte[] writeBuffer =new byte[fis.available()];
            clientSocket.getOutputStream().write(writeBuffer);
            clientSocket.shutdownOutput();//发送文件结束通知
        }catch (Exception e){}
    }

    /**
     * 发送数据
     */
    public void SendData(){
        Task.Run(()->{
            try{
                if(clientSocket!=null&&clientSocket.isConnected()){
                    String info = new Gson().toJson( new SendData());
                    byte[] writeBuffer =info.getBytes();
                    clientSocket.getOutputStream().write(writeBuffer);
                    ToastUtils.info("同步商品成功,地址："+clientSocket.getRemoteSocketAddress().toString());
                }
            }catch(Exception e){
                ToastUtils.error("发送商品数据失败："+e.getMessage());
                MessageLog.ShowError("发送数据失败:"+e.getMessage());
            }
        });
    }

    public TcpServerModel(Socket _clientSocket){
        clientSocket=_clientSocket;
        MessageLog.ShowInfo("新连接："+clientSocket.getInetAddress().toString().substring(1)+":"+clientSocket.getPort());
        try{
            SendData();
        }catch(Exception e){}
    }
    private Socket clientSocket;

    public void Close(){
        try {
            if (clientSocket != null) {
                clientSocket.close();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
