package com.bonait.bnframework.common.modbus;

import com.bonait.bnframework.common.helper.DataFormat;
import com.bonait.bnframework.common.helper.I.IReadCallBack;
import com.bonait.bnframework.common.helper.I.IWriteCallBack;

import kotlin.UInt;
import kotlin.UShort;

public interface IWrite {
    void WriteBool(String address, boolean value, int slaveId, IWriteCallBack callback);
    void WriteBool(String address, boolean[] value, int slaveId, IWriteCallBack callback);

    void WriteShort(String address, short value, int slaveId, IWriteCallBack callback);
    void WriteShort(String address, short[] value, int slaveId, IWriteCallBack callback);

    void WriteInt(String address, int value, int slaveId, IWriteCallBack callback);
    void WriteInt(String address, int[] value, int slaveId, IWriteCallBack callback);

    void WriteString(String address, String value,  int slaveId, IWriteCallBack callback);

    void WriteFloat(String address, float value, int slaveId, IWriteCallBack callback);
    void WriteFloat(String address, float[] value,  int slaveId, IWriteCallBack callback);

}
