package com.bonait.bnframework.modules.home.fragment;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.content.Context;
import android.graphics.Color;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.Spinner;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.recyclerview.widget.RecyclerView;

import com.bonait.bnframework.HBL.Dialog.AlertDialogButton;
import com.bonait.bnframework.HBL.Dialog.DialogHelper;
import com.bonait.bnframework.HBL.Dialog.WaitDialog;
import com.bonait.bnframework.HBL.NotifyPropVar;
import com.bonait.bnframework.HBL.Task;
import com.bonait.bnframework.R;
import com.bonait.bnframework.business.ConfigData;
import com.bonait.bnframework.business.DoubleFryingpanControl;
import com.bonait.bnframework.business.FryingPanPar;
import com.bonait.bnframework.business.FryingpanModbusHelper;
import com.bonait.bnframework.business.ICompleteNotify;
import com.bonait.bnframework.business.IStatusNotify;
import com.bonait.bnframework.business.PeripheralData;
import com.bonait.bnframework.business.RobotData;
import com.bonait.bnframework.business.RobotModbus;
import com.bonait.bnframework.business.YJDeviceHelper;
import com.bonait.bnframework.common.base.BaseFragment;
import com.bonait.bnframework.common.constant.ConfigName;
import com.bonait.bnframework.common.constant.MessageName;
import com.bonait.bnframework.common.db.QueryDB;
import com.bonait.bnframework.common.db.mode.BPA_GOODS;
import com.bonait.bnframework.common.db.mode.BPA_GOODSRECIPE;
import com.bonait.bnframework.common.db.res.UserLogEnum;
import com.bonait.bnframework.common.helper.I.IRun;
import com.bonait.bnframework.common.helper.MessageLog;
import com.bonait.bnframework.common.helper.TTrig;
import com.bonait.bnframework.common.linktab.LinkMode;
import com.bonait.bnframework.common.linktab.makegood.MakeGoodRightAdapter;
import com.bonait.bnframework.common.message.MessageLooper;
import com.bonait.bnframework.common.message.MessageManager;
import com.bonait.bnframework.common.model.mode.CloudGood;
import com.bonait.bnframework.device_control;
import com.bonait.bnframework.dialog.DialogManager;
import com.bonait.bnframework.dialog.DialogView;
import com.qmuiteam.qmui.widget.QMUITopBarLayout;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Random;

import butterknife.BindView;
import butterknife.ButterKnife;

public class DoubleFryingpanFragment extends BaseFragment {

    @BindView(R.id.main_btn1)
    Button btn1;

    @BindView(R.id.main_btn2)
    Button btn2;

    @BindView(R.id.btn_ssx)
    Button btn_ssx;

    @BindView(R.id.btn_warehousing)
    Button btn_warehousing;

    @BindView(R.id.btn_maintenance)
    Button btn_maintenance;

    @BindView(R.id.btn_syncGoods)
    Button btn_syncGoods;

    @BindView(R.id.main_device_control)
    Button main_device_control;

    @BindView(R.id.main_device_control2)
    Button main_device_control2;

    @BindView(R.id.tv_Status1)
    TextView tv_Status1;

    @BindView(R.id.tv_Status2)
    TextView tv_Status2;

    @BindView(R.id.robotConnectState)
    TextView robotConnectState;

    @BindView(R.id.temperature1)
    TextView temperature1;

    @BindView(R.id.temperature2)
    TextView temperature2;

//    @BindView(R.id.robot_topbar)
//    QMUITopBarLayout mTopBar;//顶部标题

    RecyclerView material;

    private DialogView mDialogVisual;
    private DialogView mParSetVisual;
    /**
     * 库位选择
     */
    private DialogView mWarehouselocSelectVisual;

    Context context;
    Activity activity;

    @Override
    protected View onCreateView() {
        View root = LayoutInflater.from(getActivity()).inflate(R.layout.fragment_double_fryingpan, null);
        ButterKnife.bind(this, root);
        context=getContext();
        activity=getActivity();
      return root;
    }

    boolean tt = true;

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        OpenGoodSelectDialog();
        Init();
        DeviceSetInit();

//        DoubleFryingpanControl.getInstance().completeNotify= new ICompleteNotify() {
//            @Override
//            public void onComplete(int num) {
//                getActivity().runOnUiThread(new Runnable() {
//                    @Override
//                    public void run() {
//                         if (num==1){
//                             btn1.setText("选择菜品");
//                             btn1.setBackgroundResource(R.drawable.button4);
//                             btn1.setVisibility(View.VISIBLE);
//                             btn1.setTextColor(Color.parseColor("#000000"));
//                             FryingpanModbusHelper.getInstance().setMake(1,false);
//                         }
//                        else if (num==2){
//                             btn2.setText("选择菜品");
//                             btn2.setBackgroundResource(R.drawable.button4);
//                             btn2.setVisibility(View.VISIBLE);
//                             btn2.setTextColor(Color.parseColor("#000000"));
//                             FryingpanModbusHelper.getInstance().setMake(2,false);
//                         }
//                    }
//                });
//            }
//        };

        btn_ssx.setBackgroundResource(PeripheralData.ConveryorLineRuning.getValue()?R.drawable.button5:R.drawable.button4);
        btn_ssx.setTextColor(PeripheralData.ConveryorLineRuning.getValue()?Color.parseColor("#ffffff"):Color.parseColor("#000000"));
        btn_ssx.setText(PeripheralData.ConveryorLineRuning.getValue()?"输送线停止":"输送线启动");

        PeripheralData.ConveryorLineRuning.ChangeNotify=(s)->{
            getActivity().runOnUiThread(()->{
                btn_ssx.setBackgroundResource(s?R.drawable.button5:R.drawable.button4);
                btn_ssx.setTextColor(s?Color.parseColor("#ffffff"):Color.parseColor("#000000"));
                btn_ssx.setText(s?"输送线停止":"输送线启动");
            });
        };

//        String status = RobotModbus.getInstance().IsConnected?"已连接":"未连接";
//        mTopBar.setTitle("机器人连接状态："+ status);

//        DoubleFryingpanControl.getInstance().statusNotify=new IStatusNotify() {
//            @Override
//            public void OnStatusChanged(String s1, String s2, String s3, String s4) {
//                getActivity().runOnUiThread(new Runnable() {
//                    @Override
//                    public void run() {
//                        tv_Status1.setText(s1);
//                        tv_Status2.setText(s2);
//                        if(s1.contains("忙碌中")||s2.contains("忙碌中")){
//                            RobotData.wokWorking = true;
//                        }else {
//                            RobotData.wokWorking = false;
//                        }
//                        String status = RobotModbus.getInstance().IsConnected?"已连接":"未连接";
//                        mTopBar.setTitle("机器人连接状态："+ status);
//                        if(!IsMaintenanceMode&&RobotData.RobotReachTending){
//                            btn_maintenance.setText("完成维护");
//                            IsMaintenanceMode=true;
//                        }
//                    }
//                });
//            }
//        };

        mDialogVisual= DialogManager.getInstance().initView(getContext(), R.layout.activity_material_view, Gravity.BOTTOM,getActivity());
        mParSetVisual = DialogManager.getInstance().initView(getContext(),R.layout.activity_par_set1,Gravity.BOTTOM,getActivity());
        mWarehouselocSelectVisual = DialogManager.getInstance().initView(getContext(),R.layout.activity_warehouseloc_select,Gravity.BOTTOM,getActivity());
    }

    private void DeviceSetInit(){
        DoubleFryingpanControl.getInstance().completeNotify=(num)->{
            getActivity().runOnUiThread(()->{
                if (num==1){
                    btn1.setText("选择菜品");
                    btn1.setBackgroundResource(R.drawable.button4);
                    btn1.setVisibility(View.VISIBLE);
                    btn1.setTextColor(Color.parseColor("#000000"));
                    FryingpanModbusHelper.getInstance().setMake(1,false);
                }
                else if (num==2){
                    btn2.setText("选择菜品");
                    btn2.setBackgroundResource(R.drawable.button4);
                    btn2.setVisibility(View.VISIBLE);
                    btn2.setTextColor(Color.parseColor("#000000"));
                    FryingpanModbusHelper.getInstance().setMake(2,false);
                }
            });
        };

        boolean Device1 = FryingpanModbusHelper.getInstance().isConnect(1);
        boolean Device2 = FryingpanModbusHelper.getInstance().isConnect(2);

        main_device_control.setText(Device1?"设备控制":"设备未连接");
        main_device_control.setEnabled(Device1?true:false);
        main_device_control.setBackgroundResource(Device1?R.drawable.button4:R.drawable.button7);
        temperature1.setVisibility(Device1?View.VISIBLE:View.GONE);

        main_device_control2.setText(Device2?"设备控制":"设备未连接");
        main_device_control2.setEnabled(Device2?true:false);
        main_device_control2.setBackgroundResource(Device2?R.drawable.button4:R.drawable.button7);
        temperature2.setVisibility(Device2?View.VISIBLE:View.GONE);

        FryingpanModbusHelper.getInstance().getModbus(1,(s)->{
            s.DeviceConnectStatus.ChangeNotify=(v->{
                getActivity().runOnUiThread(()->{
                    main_device_control.setText(v?"设备控制":"设备未连接");
                    main_device_control.setEnabled(v?true:false);
                    main_device_control.setBackgroundResource(v?R.drawable.button4:R.drawable.button7);
                    temperature1.setVisibility(v?View.VISIBLE:View.GONE);
                });
            });
            s.CurrentTemperature.Register("device1",(n)->{
                getActivity().runOnUiThread(()->{temperature1.setText("炒锅温度："+String.valueOf(n)+" ℃");});
            });
        });

        FryingpanModbusHelper.getInstance().getModbus(2,(s)->{
            s.DeviceConnectStatus.ChangeNotify=(v->{
                getActivity().runOnUiThread(()->{
                    main_device_control2.setText(v?"设备控制":"设备未连接");
                    main_device_control2.setEnabled(v?true:false);
                    main_device_control2.setBackgroundResource(v?R.drawable.button4:R.drawable.button7);
                    temperature2.setVisibility(v?View.VISIBLE:View.GONE);
                });
            });
            s.CurrentTemperature.Register("device2",(n)->{
                getActivity().runOnUiThread(()->{temperature2.setText("炒锅温度："+String.valueOf(n)+" ℃");});
            });
        });

        String status = RobotModbus.getInstance().IsConnected?"已连接":"未连接";
        robotConnectState.setText("机器人连接状态："+ status);
        robotConnectState.setTextColor(RobotModbus.getInstance().IsConnected?Color.BLUE:Color.RED);
        DoubleFryingpanControl.getInstance().statusNotify=new IStatusNotify() {
            @Override
            public void OnStatusChanged(String s1, String s2, String s3, String s4) {
                getActivity().runOnUiThread(new Runnable() {
                    @Override
                    public void run() {

                        if(s1.contains("忙碌中")||s2.contains("忙碌中")){
                            RobotData.wokWorking = true;
                        }else {
                            RobotData.wokWorking = false;
                        }

                        if(s1.equals("忙碌中")||s1.equals("空闲中"))
                        {
                            tv_Status1.setText("运行状态："+s1);
                            tv_Status1.setTextColor(Color.parseColor("#f0a732"));

                            btn1.setText(FryingpanModbusHelper.getInstance().getMake(1)?"强制取消":"选择菜品");
                            btn1.setBackgroundResource(FryingpanModbusHelper.getInstance().getMake(1)?R.drawable.button5:R.drawable.button4);
                            btn1.setEnabled(true);
                            btn1.setTextColor(Color.parseColor(FryingpanModbusHelper.getInstance().getMake(1)?"#ffffff":"#000000"));

                        }else{
                            tv_Status1.setText("连接状态：未连接");
                            tv_Status1.setTextColor(Color.parseColor("#F03274"));

                            btn1.setText("未连接");
                            btn1.setEnabled(false);
                            btn1.setBackgroundResource(R.drawable.button7);
                        }

                        if(s2.equals("忙碌中")||s2.equals("空闲中"))
                        {
                            tv_Status2.setText("运行状态："+s2);
                            tv_Status2.setTextColor(Color.parseColor("#f0a732"));

                            btn2.setText(FryingpanModbusHelper.getInstance().getMake(2)?"强制取消":"选择菜品");
                            btn2.setBackgroundResource(FryingpanModbusHelper.getInstance().getMake(2)?R.drawable.button5:R.drawable.button4);
                            btn2.setEnabled(true);
                            btn2.setTextColor(Color.parseColor(FryingpanModbusHelper.getInstance().getMake(2)?"#ffffff":"#000000"));
                        }else{
                            tv_Status2.setText("连接状态：未连接");
                            tv_Status2.setTextColor(Color.parseColor("#F03274"));

                            btn2.setText("未连接");
                            btn2.setEnabled(false);
                            btn2.setBackgroundResource(R.drawable.button7);
                        }

                        String status = RobotModbus.getInstance().IsConnected?"已连接":"未连接";
                        robotConnectState.setText("机器人连接状态："+ status);
                        robotConnectState.setTextColor(RobotModbus.getInstance().IsConnected?Color.BLUE:Color.RED);
                        if(!IsMaintenanceMode&&RobotData.RobotReachTending){
                            btn_maintenance.setText("完成维护");
                            IsMaintenanceMode=true;
                        }
                    }
                });
            }
        };

    }

    @SuppressLint("HandlerLeak")
    private Handler mHandler = new Handler() {
        @Override
        public void handleMessage(Message msg) {
            if (msg.obj.toString()== "MSG_REFRESH") {
                if(ConfigName.getInstance().cloudGoods!=null && ConfigName.getInstance().cloudGoods.size()>0)
                {
                    ArrayList<BPA_GOODS> goods= QueryDB.GetGoodsALL();
                    ArrayList<BPA_GOODSRECIPE> rec= QueryDB.GetGoodsSrecipeALL();
                    for (BPA_GOODS good:goods)
                    {
                        QueryDB.DeleteGoods(good);
                    }
                    for (BPA_GOODSRECIPE pf:rec)
                    {
                        QueryDB.DeleteGoodsSrecipe(pf);
                    }
                    for (CloudGood item : ConfigName.getInstance().cloudGoods) {
                        ConfigData.getInstance().GetGoodProcess(getContext(),item.id,false);
                    }
                    LoadingGood();
                }
                MessageLog.ShowInfo( "handleMessage: 获取商品信息成功");
            }
        }
    };

    // 隐藏弹框
    public void hide(DialogView view) {
        if (view != null) {
            if (view.isShowing()) {
                view.dismiss();
            }
        }
    }

    private void Init(){
        MessageLog.ShowInfo("Init: 开始获取云端数据");
        ConfigData.getInstance().GetOrganize(getContext());
        ConfigData.getInstance().GetGevGood(getContext(),mHandler);
        btn_syncGoods.setOnClickListener((View v)->{
            DialogHelper.showWarn(getContext(),"是否将本地商品同步到所有炒锅，此操作将覆盖炒锅本地商品，请问是否继续？",AlertDialogButton.YesNo,(s)->{
                if(s){
//                    ConfigName.getInstance().IsChangeGoods=true;
//                    TcpServer.getInstance().SendData();
                    ConfigData.getInstance().DownDataToDevice(context,activity);
                }
            });
        });

        btn_ssx.setOnClickListener((View v)->{
            if(!YJDeviceHelper.getInstance().IsConnected){
                DialogHelper.showWarn(getActivity(),"设备未连接",AlertDialogButton.OK,null);
                return;
            }
            boolean res = PeripheralData.ConveryorLineRuning.getValue();
            if(!res){
                DialogHelper.showWarn(getActivity(),"是否启动输送线！",AlertDialogButton.YesNo,(s)->{
                    if(s){
                        YJDeviceHelper.getInstance().ConveyorLineControl(true);
                    }
                });
            }else{
                YJDeviceHelper.getInstance().ConveyorLineControl(false);
            }
        });

        main_device_control.setOnClickListener((View v)->{
            device_control dc = new device_control(getContext(),getActivity(),1);
            dc.show();
        });

        main_device_control2.setOnClickListener((view)->{
            device_control dc = new device_control(getContext(),getActivity(),2);
            dc.show();
        });
    }

    private void OpenParSet(){
        //参数配置界面确认按钮
        ButtonClickBinder(mParSetVisual, R.id.parset_ok_btn,()->{
            MessageLog.ShowInfo( "onClick: 确认参数配置");

            //机器人状态验证
            if(!RobotModbus.getInstance().IsConnected){
                DialogHelper.showWarn(getActivity(),"请先连接机器人",AlertDialogButton.OK,null);
                return;
            }
            if(!RobotData.RobotReady){
                DialogHelper.showError(getActivity(),"机器人初始化失败",AlertDialogButton.OK,null);
                return;
            }

            //主料验证
            if(fry.IngredientsLocs[0]>0){
               if( !YJDeviceHelper.getInstance().MainMaterialLocVerify(fry.IngredientsLocs[0])){
                   DialogHelper.showError(getActivity(),"主料位置 "+fry.IngredientsLocs[0] +"未检测到有物料！",AlertDialogButton.OK,null);
                   return;
               }
            }
            if(fry.IngredientsLocs[1]>0){
                if( !YJDeviceHelper.getInstance().MainMaterialLocVerify(fry.IngredientsLocs[1])){
                    DialogHelper.showError(getActivity(),"主料位置 "+fry.IngredientsLocs[1] +"未检测到有物料！",AlertDialogButton.OK,null);
                    return;
                }
            }

            if(fry.IngredientsLocs[2]>0){
                if( !YJDeviceHelper.getInstance().MainMaterialLocVerify(fry.IngredientsLocs[2])){
                    DialogHelper.showError(getActivity(),"主料位置 "+fry.IngredientsLocs[2] +"未检测到有物料！",AlertDialogButton.OK,null);
                    return;
                }
            }

            //辅料验证
            if(fry.AccessoriesLocs[0]>0){
                if( !YJDeviceHelper.getInstance().AccessoriesLocVerify(fry.AccessoriesLocs[0])){
                    DialogHelper.showError(getActivity(),"辅料位置 "+fry.AccessoriesLocs[0] +"未检测到有物料！",AlertDialogButton.OK,null);
                    return;
                }
            }
            if(fry.AccessoriesLocs[1]>0){
                if( !YJDeviceHelper.getInstance().AccessoriesLocVerify(fry.AccessoriesLocs[1])){
                    DialogHelper.showError(getActivity(),"辅料位置 "+fry.AccessoriesLocs[1] +"未检测到有物料！",AlertDialogButton.OK,null);
                    return;
                }
            }

            DoubleFryingpanControl.getInstance(). GoodDown(fry.GoodID,fry.FryingPanNum);

            WaitDialog.Show("商品验证","正在验证商品...",getContext(),getActivity());
            Task.Run(()->{
                long startTime=System.currentTimeMillis();
                while(!DoubleFryingpanControl.getInstance().GetGoodVery(fry.FryingPanNum)&&(System.currentTimeMillis()-startTime)<=4000){Task.Delay(100);}
                if (DoubleFryingpanControl.getInstance().GetGoodVery(fry.FryingPanNum)){
                    WaitDialog.AddText("商品验证成功");
                    WaitDialog.Dismiss();
                    getActivity().runOnUiThread(()->{
                        if (fry.FryingPanNum==1){
                            btn1.setText("强制取消");
                            btn1.setBackgroundResource(R.drawable.button5);
                            btn1.setTextColor(Color.parseColor("#ffffff"));
                            FryingpanModbusHelper.getInstance().setMake(1,true);
                        }
                        else if (fry.FryingPanNum==2){
                            btn2.setText("强制取消");
                            btn2.setBackgroundResource(R.drawable.button5);
                            btn2.setTextColor(Color.parseColor("#ffffff"));
                            FryingpanModbusHelper.getInstance().setMake(2,true);
                        }
                        DoubleFryingpanControl.getInstance().FryingPan.put(fry.FryingPanNum,fry);
                        fry=new FryingPanPar();
                        DialogManager.getInstance().hide(mParSetVisual);//关闭参数设置窗口
                    });
                }
                else{
                    WaitDialog.TimeOut("商品验证失败");
                }
            });
        });

        //参数配置界面取消按钮
        ButtonClickBinder(mParSetVisual, R.id.parset_cancel_btn, ()->{
            MessageLog.ShowInfo( "onClick: 退出参数配置");
            fry=new FryingPanPar();
            DialogManager.getInstance().hide(mParSetVisual);//关闭参数设置窗口
        });

        DialogManager.getInstance().hide(mDialogVisual);//关闭商品选择窗口
        try {
            DialogManager.getInstance().show(mParSetVisual,R.id.parset_close_dialog); //打开参数设置窗口
        }
        catch (RuntimeException ex)
        {
            MessageLog.ShowUserMessage( UserLogEnum.订单处理日志 ,"打开参数配置弹框出错："+ex.getMessage());
        }
        catch(Exception ex){
            MessageLog.ShowUserMessage( UserLogEnum.订单处理日志 ,"打开参数配置弹框出错111："+ex.getMessage());
        }

        ParSetInit(R.id.location_selection_1,new String[] {"0", "1", "2", "3", "4","5","6"});
        ParSetInit(R.id.location_selection_2,new String[] {"0", "1", "2", "3", "4","5","6"});
        ParSetInit(R.id.location_selection_3,new String[] {"0", "1", "2", "3", "4","5","6"});
        ParSetInit(R.id.accessories_selection_1,new String[] {"0", "1", "2", "3", "4","5","6"});
        ParSetInit(R.id.accessories_selection_2,new String[] {"0", "1", "2", "3", "4","5","6"});
    }

    int Warehouseloc=0;

    /**
     * 手动入库
     */
    private void WarehouselocInit(){
        ButtonClickBinder(mWarehouselocSelectVisual, R.id.parset_ok_btn,()->{
            if(Warehouseloc>=1&&Warehouseloc<=6){
                btn_warehousing.setEnabled(false);//禁用按钮
                btn_warehousing.setText("入库中...");
                RobotModbus.getInstance().WriteShort("GI0",(short) (Warehouseloc+30),1,null);//写入机器人主任务,指定入库位置
                Task.Run(()->{
                    while(!RobotData.RobotWarehousingComplete[Warehouseloc-1]){Task.Delay(100);}
                    getActivity().runOnUiThread(()->{
                        btn_warehousing.setText("入库");
                        btn_warehousing.setEnabled(true);//禁用按钮
                    });
                    Warehouseloc=0;
                });
            }else{
                DialogHelper.showError(getActivity(),"错误的库位编号",AlertDialogButton.OK,null);
            }
        });

        //参数配置界面取消按钮
        ButtonClickBinder(mWarehouselocSelectVisual, R.id.parset_cancel_btn, ()->{
            MessageLog.ShowInfo("onClick: 退出参数配置");
            Warehouseloc=0;
            DialogManager.getInstance().hide(mWarehouselocSelectVisual);//关闭参数设置窗口
        });

        String[] args=new String[] {"0", "1", "2", "3", "4","5","6"};
        Spinner sp = mWarehouselocSelectVisual.findViewById(R.id.location_selection_1);
        ArrayAdapter<String> starAdapter = new ArrayAdapter<String>(getContext(), R.layout.select_item, args);
        sp.setAdapter(starAdapter);
        sp.setSelection(0);
        sp.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> adapterView, View view, int i, long l) {
                if(R.id.location_selection_1==R.id.location_selection_1) {
                    Warehouseloc=Integer.parseInt(adapterView.getItemAtPosition(i).toString());
                }
            }

            @Override
            public void onNothingSelected(AdapterView<?> adapterView) {

            }
        });
    }

    FryingPanPar fry=new FryingPanPar();
    boolean IsMaintenanceMode=false;
    private void OpenGoodSelectDialog()
    {
        MessageManager.getInstance().registerMessageReceiver(getActivity(), MessageName.ClickMakeGoodNew, new MessageLooper.OnMessageListener() {
            @Override
            public void onMessage(Object msg) {
                if (msg != null) {
                    BPA_GOODS goods = (BPA_GOODS) msg;
                    fry.GoodID= goods.id;

                    if(!RobotModbus.getInstance().IsConnected){
                        DialogHelper.showError(getActivity(),"机器人未连接",AlertDialogButton.OK,null);
                        return;
                    }

                    if(!RobotData.RobotReady){
                        DialogHelper.showError(getActivity(),"机器人初始化失败",AlertDialogButton.OK,null);
                        return;
                    }

                    OpenParSet();
                }
            }
        });

        btn1.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view){
                ProductSelectionButtonBinder(R.id.main_btn1,1);
            }
        });

        btn2.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view){
                ProductSelectionButtonBinder(R.id.main_btn2,2);
            }
        });

        if(btn_warehousing==null||btn_maintenance==null)return;

        //手动入库
        btn_warehousing.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view){
                WarehouselocInit();
                mWarehouselocSelectVisual.setCanceledOnTouchOutside(false);
                DialogManager.getInstance().show(mWarehouselocSelectVisual,R.id.parset_close_dialog); //打开位置选择窗口
            }
        });

        //机器人维护
        btn_maintenance.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view){
                if(!RobotModbus.getInstance().IsConnected){
                    DialogHelper.showError(getActivity(),"机器人未连接",AlertDialogButton.OK,null);
                    return;
                }

                if(!RobotData.RobotReady){
                    DialogHelper.showError(getActivity(),"机器人初始化失败",AlertDialogButton.OK,null);
                    return;
                }

                if(!RobotData.RobotReachTending)
                {
                    if(RobotData.RobotIdle){
                        DialogHelper.showWarn(getActivity(),"是否进入机器人维护模式?",AlertDialogButton.YesNo,(s)->{
                            if(s){
                                btn_maintenance.setEnabled(false);//禁用按钮
                                btn_maintenance.setText("维护模式中...");
                                RobotModbus.getInstance().WriteShort("GI0",(short) (41),1,null);//写入机器人主任务,指定入库位置
                                Task.Run(()->{
                                    while(!RobotData.RobotReachTending){Task.Delay(100);}
                                    getActivity().runOnUiThread(()->{
                                        btn_maintenance.setText("完成维护");
                                        btn_maintenance.setEnabled(true);//取消禁用按钮
                                    });
                                });
                            }
                        });
                    }
                    else{
                        DialogHelper.showWarn(getActivity(),"机器人忙碌中，请稍后",AlertDialogButton.OK,null);
                    }
                }
                else
                {
                    RobotModbus.getInstance().WriteBool(DoubleFryingpanControl.getInstance().RobotAddress("M520"), true,1,null);//写入机器人主任务,指定入库位置
                    btn_maintenance.setText("维护");
                }

            }
        });
    }

    /**
     * 同步商品
     */
    private void synchronous(){
        Button btn=mDialogVisual.findViewById(R.id.synchronous);
        btn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Init();
                LoadingGood();
            }
        });
    }

    /**
     * 加载商品
     */
    public void LoadingGood() {
        ArrayList<BPA_GOODS> goods= QueryDB.GetGoodsALL();
        ArrayList<BPA_GOODS> goodsm=new ArrayList<>();
        if (goods.size()>0){
            for (BPA_GOODS item:goods)goodsm.add(item);
        }else{
            for(CloudGood item: ConfigName.getInstance().cloudGoods){
                BPA_GOODS bpa=new BPA_GOODS();
                bpa.name=item.goods_Name;
                bpa.url=item.goods_ImgUrl;
                bpa.id=item.id;
                goodsm.add(bpa);
            }
        }
        List<LinkMode> Fdata = new ArrayList<>();
        Fdata.add(new LinkMode("main", Arrays.asList(goodsm.toArray()),true));
        MakeGoodRightAdapter rightAdapter = new MakeGoodRightAdapter(R.layout.item_right_lc, Fdata, getResources());
        material.setAdapter(rightAdapter);

    }

    private void ParSetInit(int id,String[] args)
    {
        Spinner sp = mParSetVisual.findViewById(id);
        ArrayAdapter<String> starAdapter = new ArrayAdapter<String>(getContext(), R.layout.select_item, args);
        sp.setAdapter(starAdapter);
        sp.setSelection(0);
        sp.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> adapterView, View view, int i, long l) {
                if(R.id.location_selection_1==id) {
                    fry.IngredientsLocs[0]=Integer.parseInt(adapterView.getItemAtPosition(i).toString());
                }
                else if  (R.id.location_selection_2==id) {
                    fry.IngredientsLocs[1]=Integer.parseInt(adapterView.getItemAtPosition(i).toString());;
                }
                else if  (R.id.location_selection_3==id) {
                    fry.IngredientsLocs[2]=Integer.parseInt(adapterView.getItemAtPosition(i).toString());;
                }
                else if  (R.id.accessories_selection_1==id) {
                    fry.AccessoriesLocs[0]=Integer.parseInt(adapterView.getItemAtPosition(i).toString());;
                }
                else if  (R.id.accessories_selection_2==id) {
                    fry.AccessoriesLocs[1]=Integer.parseInt(adapterView.getItemAtPosition(i).toString());;
                }
            }

            @Override
            public void onNothingSelected(AdapterView<?> adapterView) {

            }
        });
    }

    /**
     * 菜品选择事件执行
     * @param id 按钮id
     * @param FiryNum 炒锅编号
     */
    private void ProductSelectionButtonBinder(int id,int FiryNum){
        Button btn =getActivity().findViewById(id);
        if(btn.getText().equals("强制取消"))
        {
            DialogHelper.showWarn(getActivity(),"是否强制结束任务?",AlertDialogButton.YesNo,(s)->{
                if(s){
                    DoubleFryingpanControl.getInstance().SetForceEnd(FiryNum);
                    btn.setVisibility(View.GONE);
                    FryingpanModbusHelper.getInstance().setMake(FiryNum,false);
                }
            });

        }
        else
        {
            fry.FryingPanNum=FiryNum;
            mDialogVisual.setCanceledOnTouchOutside(false);
            material=mDialogVisual.findViewById(R.id.rv_material);
            synchronous();
            LoadingGood();
            if(!getActivity().isFinishing())
                DialogManager.getInstance().show(mDialogVisual,R.id.close_dialog); //打开商品选择窗口
        }
    }

    /**
     * 弹框按钮事件绑定
     * @param dv 弹框页面
     * @param id 按钮id
     * @param action 执行委托
     */
    private void ButtonClickBinder(DialogView dv,int id, IRun action){
        if(dv!=null&& !dv.findViewById(id).hasOnClickListeners()){
            dv.findViewById(id).setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View view) {
                    if(action!=null) action.Run();
                }
            });
        }
    }



}
